﻿import util.*;
import mvc.*;

/**
 * 指定MVC三劍客中的「外觀（【斜體】View【/斜體】）」所必須提供的最基本的服務。
 */
interface mvc.View {
  /**
   * 設定這個「外觀」所觀察的「模型」
   */
  public function setModel (m:Observable):Void;

  /**
   * 傳回這個「外觀」所觀察的「模型」
   */
  public function getModel (  ):Observable;

  /**
   * 設定這個「外觀」的「控制邏輯」
   */
  public function setController (c:Controller):Void;

  /**
   * 傳回這個「外觀」的「控制邏輯」
   */
  public function getController (  ):Controller;

  /**
   * 傳回這個「外觀」的預設「控制邏輯」
   */
  public function defaultController (model:Observable):Controller;
}