﻿import mvcclock.ClockModel;
import mvc.*;
import util.*;

/**
 * 依據用戶的輸入，改變ClockModel的資料。
 * 提供通用的服務給任何需要的外觀。
 */
class mvcclock.ClockController extends AbstractController {

  /**
   * 建構子
   *
   * @param   cm   要被修改的模型
   */
  public function ClockController (cm:Observable) {
    super(cm);
  }

  /**
   * 啟動時鐘
   */
  public function startClock (  ):Void {
    ClockModel(getModel()).start(  );
  }

  /**
   * 停止時鐘
   */
  public function stopClock (  ):Void {
    ClockModel(getModel()).stop(  );
  }

  /**
   * 把時鐘的時間重置成午夜12點（0時）。
   */
  public function resetClock (  ):Void {
    setTime(0, 0, 0);
  }

  /**
   * 改變時鐘的時間
   *
   * @param   h   新的小時，從0到23。
   * @param   m   新的分鐘，從0到59。
   * @param   s   新的秒，從0到59。
   */
  public function setTime (h:Number, m:Number, s:Number):Void {
    ClockModel(getModel(  )).setTime(h, m, s);
  }

  // 對於下列的三個方法，控制邏輯可以
  // 提供在模型中更改資料的便利方法。

  /**
   * 只設定時鐘的小時
   *
   * @param   h   新的小時
   */
  public function setHour (h:Number):Void {
    ClockModel(getModel(  )).setTime(h, null, null);
  }

  /**
   * 只設定時鐘的分鐘
   *
   * @param   m   新的分鐘
   */
  public function setMinute (m:Number):Void {
    ClockModel(getModel(  )).setTime(null, m, null);
  }

  /**
   * 只設定時鐘的秒數
   *
   * @param   s   新的秒數
   */
  public function setSecond (s:Number):Void {
    ClockModel(getModel(  )).setTime(null, null, s);
  }

  /**
   * 從ClockTools這個外觀的「開始」、
   * 「停止」和「重置」鈕處理事件。
   */
  public function click (e:Object):Void {
    switch (e.target._name) {
      case "start":
        startClock(  );
        break;
      case "stop":
        stopClock(  );
        break;
      case "reset":
        resetClock(  );      
        break;
    }
  }
}